package com.tencent.crypt;

import java.io.ByteArrayOutputStream;
import java.util.Random;

/* loaded from: com_tencent_crypt.jar:com/tencent/crypt/Crypt.class */
public class Crypt {
    private byte[] plain;
    private byte[] prePlain;
    private byte[] out;
    private int crypt;
    private int preCrypt;
    private int pos;
    private int padding;
    private byte[] key;
    private int contextStart;
    private static final Random random = new Random();
    private boolean header = true;
    private final ByteArrayOutputStream bas = new ByteArrayOutputStream(8);

    public byte[] decrypt(byte[] in, int offset, int len, byte[] k) {
        if (k == null) {
            return null;
        }
        this.preCrypt = 0;
        this.crypt = 0;
        this.key = k;
        byte[] m = new byte[offset + 8];
        if (len % 8 != 0 || len < 16) {
            return null;
        }
        this.prePlain = decipher(in, offset);
        this.pos = this.prePlain[0] & 7;
        int count = (len - this.pos) - 10;
        if (count < 0) {
            return null;
        }
        for (int i = offset; i < m.length; i++) {
            m[i] = 0;
        }
        this.out = new byte[count];
        this.preCrypt = 0;
        this.crypt = 8;
        this.contextStart = 8;
        this.pos++;
        this.padding = 1;
        while (this.padding <= 2) {
            if (this.pos < 8) {
                this.pos++;
                this.padding++;
            }
            if (this.pos == 8) {
                m = in;
                decrypt8Bytes(in, offset, len);
            }
        }
        int i2 = 0;
        while (count != 0) {
            if (this.pos < 8) {
                this.out[i2] = (byte) (m[(offset + this.preCrypt) + this.pos] ^ this.prePlain[this.pos]);
                i2++;
                count--;
                this.pos++;
            }
            if (this.pos == 8) {
                m = in;
                this.preCrypt = this.crypt - 8;
                decrypt8Bytes(in, offset, len);
            }
        }
        this.padding = 1;
        while (this.padding < 8) {
            if (this.pos < 8) {
                if ((m[(offset + this.preCrypt) + this.pos] ^ this.prePlain[this.pos]) != 0) {
                    return null;
                }
                this.pos++;
            }
            if (this.pos == 8) {
                m = in;
                this.preCrypt = this.crypt;
                decrypt8Bytes(in, offset, len);
            }
            this.padding++;
        }
        return this.out;
    }

    public byte[] decrypt(byte[] in, byte[] k) {
        return decrypt(in, 0, in.length, k);
    }

    public byte[] encrypt(byte[] in, int offset, int len, byte[] k) {
        if (k == null) {
            return in;
        }
        this.plain = new byte[8];
        this.prePlain = new byte[8];
        this.padding = 0;
        this.preCrypt = 0;
        this.crypt = 0;
        this.key = k;
        this.header = true;
        this.pos = (len + 10) % 8;
        if (this.pos != 0) {
            this.pos = 8 - this.pos;
        }
        this.out = new byte[len + this.pos + 10];
        this.plain[0] = (byte) ((rand() & 248) | this.pos);
        for (int i = 1; i <= this.pos; i++) {
            this.plain[i] = (byte) (rand() & 255);
        }
        this.pos++;
        for (int i2 = 0; i2 < 8; i2++) {
            this.prePlain[i2] = 0;
        }
        this.padding = 1;
        while (this.padding <= 2) {
            if (this.pos < 8) {
                byte[] bArr = this.plain;
                int i3 = this.pos;
                this.pos = i3 + 1;
                bArr[i3] = (byte) (rand() & 255);
                this.padding++;
            }
            if (this.pos == 8) {
                encrypt8Bytes();
            }
        }
        int i4 = offset;
        while (len > 0) {
            if (this.pos < 8) {
                byte[] bArr2 = this.plain;
                int i5 = this.pos;
                this.pos = i5 + 1;
                int i6 = i4;
                i4++;
                bArr2[i5] = in[i6];
                len--;
            }
            if (this.pos == 8) {
                encrypt8Bytes();
            }
        }
        this.padding = 1;
        while (this.padding <= 7) {
            if (this.pos < 8) {
                byte[] bArr3 = this.plain;
                int i7 = this.pos;
                this.pos = i7 + 1;
                bArr3[i7] = 0;
                this.padding++;
            }
            if (this.pos == 8) {
                encrypt8Bytes();
            }
        }
        return this.out;
    }

    public byte[] encrypt(byte[] in, byte[] k) {
        return encrypt(in, 0, in.length, k);
    }

    private byte[] encipher(byte[] in) {
        int loop = 16;
        long y = getUnsignedInt(in, 0, 4);
        long z = getUnsignedInt(in, 4, 4);
        long a = getUnsignedInt(this.key, 0, 4);
        long b = getUnsignedInt(this.key, 4, 4);
        long c = getUnsignedInt(this.key, 8, 4);
        long d = getUnsignedInt(this.key, 12, 4);
        long sum = 0;
        long delta = (-1640531527) & 4294967295L;
        while (true) {
            int i = loop;
            loop--;
            if (i > 0) {
                sum = (sum + delta) & 4294967295L;
                y = (y + ((((z << 4) + a) ^ (z + sum)) ^ ((z >>> 5) + b))) & 4294967295L;
                z = (z + ((((y << 4) + c) ^ (y + sum)) ^ ((y >>> 5) + d))) & 4294967295L;
            } else {
                this.bas.reset();
                writeInt((int) y);
                writeInt((int) z);
                return this.bas.toByteArray();
            }
        }
    }

    private byte[] decipher(byte[] in, int offset) {
        int loop = 16;
        long y = getUnsignedInt(in, offset, 4);
        long z = getUnsignedInt(in, offset + 4, 4);
        long a = getUnsignedInt(this.key, 0, 4);
        long b = getUnsignedInt(this.key, 4, 4);
        long c = getUnsignedInt(this.key, 8, 4);
        long d = getUnsignedInt(this.key, 12, 4);
        long sum = (-478700656) & 4294967295L;
        long delta = (-1640531527) & 4294967295L;
        while (true) {
            int i = loop;
            loop--;
            if (i > 0) {
                z = (z - ((((y << 4) + c) ^ (y + sum)) ^ ((y >>> 5) + d))) & 4294967295L;
                y = (y - ((((z << 4) + a) ^ (z + sum)) ^ ((z >>> 5) + b))) & 4294967295L;
                sum = (sum - delta) & 4294967295L;
            } else {
                this.bas.reset();
                writeInt((int) y);
                writeInt((int) z);
                return this.bas.toByteArray();
            }
        }
    }

    private void writeInt(int t) {
        this.bas.write(t >>> 24);
        this.bas.write(t >>> 16);
        this.bas.write(t >>> 8);
        this.bas.write(t);
    }

    private byte[] decipher(byte[] in) {
        return decipher(in, 0);
    }

    private void encrypt8Bytes() {
        this.pos = 0;
        while (this.pos < 8) {
            if (this.header) {
                byte[] bArr = this.plain;
                int i = this.pos;
                bArr[i] = (byte) (bArr[i] ^ this.prePlain[this.pos]);
            } else {
                byte[] bArr2 = this.plain;
                int i2 = this.pos;
                bArr2[i2] = (byte) (bArr2[i2] ^ this.out[this.preCrypt + this.pos]);
            }
            this.pos++;
        }
        byte[] crypted = encipher(this.plain);
        System.arraycopy(crypted, 0, this.out, this.crypt, 8);
        this.pos = 0;
        while (this.pos < 8) {
            byte[] bArr3 = this.out;
            int i3 = this.crypt + this.pos;
            bArr3[i3] = (byte) (bArr3[i3] ^ this.prePlain[this.pos]);
            this.pos++;
        }
        System.arraycopy(this.plain, 0, this.prePlain, 0, 8);
        this.preCrypt = this.crypt;
        this.crypt += 8;
        this.pos = 0;
        this.header = false;
    }

    private void decrypt8Bytes(byte[] in, int offset, int len) {
        this.pos = 0;
        while (this.pos < 8) {
            if (this.contextStart + this.pos >= len) {
                return;
            }
            byte[] bArr = this.prePlain;
            int i = this.pos;
            bArr[i] = (byte) (bArr[i] ^ in[(offset + this.crypt) + this.pos]);
            this.pos++;
        }
        this.prePlain = decipher(this.prePlain);
        this.contextStart += 8;
        this.crypt += 8;
        this.pos = 0;
    }

    private int rand() {
        return random.nextInt();
    }

    public static long getUnsignedInt(byte[] in, int offset, int len) {
        int end;
        long ret = 0;
        if (len > 8) {
            end = offset + 8;
        } else {
            end = offset + len;
        }
        for (int i = offset; i < end; i++) {
            ret = (ret << 8) | (in[i] & 255);
        }
        return (ret & 4294967295L) | (ret >>> 32);
    }
}
